Package ghidra.trace.database.symbol

# Class AbstractDBTraceSymbolSingleTypeWithLocationView<T extends AbstractDBTraceSymbol>

java.lang.Object
ghidra.trace.database.symbol.AbstractDBTraceSymbolSingleTypeView<T>
ghidra.trace.database.symbol.AbstractDBTraceSymbolSingleTypeWithLocationView<T>

Direct Known Subclasses:
  `DBTraceLabelSymbolView`

public abstract class AbstractDBTraceSymbolSingleTypeWithLocationView<T extends AbstractDBTraceSymbol> extends AbstractDBTraceSymbolSingleTypeView<T>

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected class`
  `AbstractDBTraceSymbolSingleTypeWithLocationView.CacheForGetSymbolsAtQueries`
  `protected static class`
  `AbstractDBTraceSymbolSingleTypeWithLocationView.GetSymbolsKey`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final int`
  `CACHE_ADDRESS_BREADTH`
  `protected static final int`
  `CACHE_MAX_POINTS`
  `protected static final int`
  `CACHE_SNAP_BREADTH`
  `protected final AbstractDBTraceSymbolSingleTypeWithLocationView<T>.CacheForGetSymbolsAtQueries`
  `cacheForAt`

  ### Fields inherited from class ghidra.trace.database.symbol.AbstractDBTraceSymbolSingleTypeView

  `manager, store, symbolsByName, symbolsByParentID, typeID, view`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractDBTraceSymbolSingleTypeWithLocationView(DBTraceSymbolManager manager, byte typeID, DBCachedObjectStore<T> store)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Collection<? extends T>`
  `getAt(long snap, Address address, boolean includeDynamicSymbols)`
  Get the symbols at the given snap and address, starting with the primary
  `T`
  `getChildWithNameAt(String name, long snap, Address address, TraceNamespaceSymbol parent)`
  `Collection<? extends T>`
  `getIntersecting(Lifespan span, AddressRange range, boolean includeDynamicSymbols)`
  Get intersecting things in no particular order
  `Collection<? extends T>`
  `getIntersecting(Lifespan span, AddressRange range, boolean includeDynamicSymbols, boolean forward)`
  `void`
  `invalidateCache()`

  ### Methods inherited from class ghidra.trace.database.symbol.AbstractDBTraceSymbolSingleTypeView

  `constructView, getAll, getByKey, getChildren, getChildrenNamed, getManager, getNamed, getWithMatchingName, scanByName`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### CACHE_SNAP_BREADTH

    protected static final int CACHE_SNAP_BREADTH
    See Also:
      - Constant Field Values

  - ### CACHE_ADDRESS_BREADTH

    protected static final int CACHE_ADDRESS_BREADTH
    See Also:
      - Constant Field Values

  - ### CACHE_MAX_POINTS

    protected static final int CACHE_MAX_POINTS
    See Also:
      - Constant Field Values

  - ### cacheForAt

    protected final AbstractDBTraceSymbolSingleTypeWithLocationView<T extends AbstractDBTraceSymbol>.CacheForGetSymbolsAtQueries cacheForAt

- ## Constructor Details

  - ### AbstractDBTraceSymbolSingleTypeWithLocationView

    public AbstractDBTraceSymbolSingleTypeWithLocationView(DBTraceSymbolManager manager, byte typeID, DBCachedObjectStore<T> store)

- ## Method Details

  - ### getChildWithNameAt

    public T getChildWithNameAt(String name, long snap, Address address, TraceNamespaceSymbol parent)

  - ### getAt

    public Collection<? extends T> getAt(long snap, Address address, boolean includeDynamicSymbols)
    Get the symbols at the given snap and address, starting with the primary
    Parameters:
      `snap` - the snapshot key
      `address` - the address
      `includeDynamicSymbols` - true to include dynamic symbols
    Returns:
      the collection

  - ### getIntersecting

    public Collection<? extends T> getIntersecting(Lifespan span, AddressRange range, boolean includeDynamicSymbols)
    Get intersecting things in no particular order
    Parameters:
      `span` - the span of snapshots
      `range` - the range of addresses
      `includeDynamicSymbols` - true to include dynamic symbols
    Returns:
      the collection

  - ### getIntersecting

    public Collection<? extends T> getIntersecting(Lifespan span, AddressRange range, boolean includeDynamicSymbols, boolean forward)

  - ### invalidateCache

    public void invalidateCache()
    Overrides:
      `invalidateCache` in class `AbstractDBTraceSymbolSingleTypeView<T extends AbstractDBTraceSymbol>`